import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { useCallback, useState } from 'react';
import PropTypes from 'prop-types';
import { debounce } from '@s-ui/js/lib/function/debounce.js';
import Injector from '@s-ui/react-primitive-injector';
import getCroppedImg from './utils/cropImage.js';
import { baseClass, DEFAULT_ASPECT, getRotationDegrees, noop } from './config.js';
import ImageEditorCropper from './ImageEditorCropper.js';
import ImageEditorDefault from './ImageEditorDefault.js';
import ImageEditorSliders from './ImageEditorSliders.js';
import { debouncingTimePropType } from './prop-types.js';
import { jsx as _jsx } from "react/jsx-runtime";
var MoleculeImageEditor = function MoleculeImageEditor(_ref) {
  var _ref$aspect = _ref.aspect,
    aspect = _ref$aspect === void 0 ? DEFAULT_ASPECT : _ref$aspect,
    cropLabelIcon = _ref.cropLabelIcon,
    cropLabelText = _ref.cropLabelText,
    debouncingTime = _ref.debouncingTime,
    image = _ref.image,
    onChange = _ref.onChange,
    _ref$onCropping = _ref.onCropping,
    onCropping = _ref$onCropping === void 0 ? noop : _ref$onCropping,
    rotateLabelIcon = _ref.rotateLabelIcon,
    rotateLabelText = _ref.rotateLabelText,
    _ref$children = _ref.children,
    children = _ref$children === void 0 ? /*#__PURE__*/_jsx(ImageEditorDefault, {}) : _ref$children;
  var _useState = useState({
      x: 0,
      y: 0
    }),
    crop = _useState[0],
    cropSetter = _useState[1];
  var _useState2 = useState(0),
    rotation = _useState2[0],
    rotationSetter = _useState2[1];
  var _useState3 = useState(0),
    zoom = _useState3[0],
    zoomSetter = _useState3[1];
  var setCrop = debouncingTime === undefined ? cropSetter : debounce(cropSetter, debouncingTime);
  var setRotation = debouncingTime === undefined ? rotationSetter : debounce(rotationSetter, debouncingTime);
  var setZoom = debouncingTime === undefined ? zoomSetter : debounce(zoomSetter, debouncingTime);
  var onCropComplete = useCallback( /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(croppedArea, croppedAreaPixels) {
      var cropCompleteHandler,
        callback,
        _len,
        args,
        _key,
        _args2 = arguments;
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              cropCompleteHandler = /*#__PURE__*/function () {
                var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
                  var rotationDegrees, _yield$getCroppedImg, croppedImageUrl, croppedImageBlobObject;
                  return _regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          rotationDegrees = getRotationDegrees(rotation);
                          onCropping(true);
                          _context.next = 4;
                          return getCroppedImg(image, croppedAreaPixels, rotationDegrees);
                        case 4:
                          _yield$getCroppedImg = _context.sent;
                          croppedImageUrl = _yield$getCroppedImg[0];
                          croppedImageBlobObject = _yield$getCroppedImg[1];
                          onChange(croppedImageUrl, croppedImageBlobObject);
                          onCropping(false);
                        case 9:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));
                return function cropCompleteHandler() {
                  return _ref3.apply(this, arguments);
                };
              }();
              callback = debouncingTime === undefined ? cropCompleteHandler : debounce(cropCompleteHandler, debouncingTime);
              for (_len = _args2.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
                args[_key - 2] = _args2[_key];
              }
              _context2.next = 5;
              return callback.apply(void 0, [croppedArea, croppedAreaPixels].concat(args));
            case 5:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return function (_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }(), [rotation, onCropping, image, onChange, debouncingTime]);
  return /*#__PURE__*/_jsx("div", {
    className: baseClass,
    children: /*#__PURE__*/_jsx(Injector, {
      image: image,
      crop: crop,
      zoom: zoom,
      rotation: rotation,
      aspect: aspect,
      onCropChange: setCrop,
      onCropComplete: onCropComplete,
      onRotationChange: setRotation,
      onZoomChange: function onZoomChange(zoom) {
        return setZoom((zoom - 1) * 100);
      },
      rotateLabelIcon: rotateLabelIcon,
      rotateLabelText: rotateLabelText,
      cropLabelIcon: cropLabelIcon,
      cropLabelText: cropLabelText,
      onZoomSliderChange: function onZoomSliderChange(event, _ref4) {
        var value = _ref4.value;
        return setZoom(value);
      },
      onRotateSliderChange: function onRotateSliderChange(event, _ref5) {
        var value = _ref5.value;
        return setRotation(value);
      },
      children: children
    })
  });
};
MoleculeImageEditor.displayName = 'MoleculeImageEditor';
export default MoleculeImageEditor;
export { ImageEditorCropper as MoleculeImageEditorCropper, ImageEditorSliders as MoleculeImageEditorSliders };